
/*
	From Linux 4D Project
	
	Author: Matteo Fasanella

*/


#include <stdio.h>
#include <string.h>
#include <fcntl.h>


typedef struct head {
    char header[128];
    struct cell *table;
} head;


typedef struct action {

    char action[128];
    char parms[128];
    struct head *next_table;		// per la go

    struct action *prev_action;
    struct action *next_action;

} action;


typedef struct cell {
    char event[128];
    struct action *actions;
    
    struct cell *prev_cell;
    struct cell *next_cell;
} cell;



typedef struct domain {
    char header[128];
    char con_name[64];
    struct head *headptr;
    struct domain *next;
} domain;

typedef struct go {
    struct action *actionptr;
    struct go *next;
} go;



struct domain *create_rules(char *);
int print_rules(struct domain *);



/*
int main() {

struct domain *basedom=NULL;


    basedom = create_rules("rules/f1.rul");
    
    print_rules(basedom);

return 0;
}
*/



struct domain *create_rules(char *filename) {


int fileptr, nread=1, i=0, k=0, esci=0;
char *linea, leggo=' ', *leftm, *rightm, *parms, con_name[64]="";
struct head *base=NULL, *currhead=NULL;
struct cell *currcell=NULL, *prevcell=NULL;
struct action *curract=NULL, *prevact=NULL;
struct domain *basedom=NULL, *currdom=NULL, *prevdom=NULL;
struct go *basego=NULL, *currgo=NULL, *prevgo=NULL;

linea = (char *) malloc((1024 * sizeof(char)));
leftm = (char *) malloc((128 * sizeof(char)));
rightm = (char *) malloc((128 * sizeof(char)));
parms = (char *) malloc((128 * sizeof(char)));



if ( (fileptr=open(filename, O_RDONLY)) < 0) {
//    basedom = (struct domain *) malloc(sizeof(struct domain));
//    bzero(basedom, sizeof(struct domain));
//    return basedom;
//    printf("Errore apertura: %s\n", filename);
    return NULL;
}



while (nread>0) { 

    nread = read(fileptr, &linea[i++] , 1);
    while (linea[i-1] != '\n' && nread>0) nread = read(fileptr, &linea[i++] , 1);
    linea[i-1] = '\0';
//    printf("linea: %s", linea);
    leggo = ' ';
    i=0;   k=0;

// case sul "tipo"  
// se '[', crea nuova tabella
// altrimenti parse x avere left_member, right_member, parms (x es nel 
// caso di SayText)

    while (linea[i] == ' ') i++;

    if (linea[i] == '#') {	// commenti
        goto end_cicle;
    }

    if (linea[i] == '(') {	//  crea nuova tabella
	i++;
	while ( (linea[i] != ')') ) 
	    con_name[k++] = linea[i++];
	con_name[k] = '\0';
	goto end_cicle;
    }
    
    if (linea[i] == '[') {	//  crea nuova tabella
	i++;
	while ( (linea[i] != ']') ) 
	    leftm[k++] = linea[i++];
	leftm[k] = '\0';

	currhead = (struct head *) malloc(sizeof(head));
	strcpy (currhead->header, leftm);
	
	if (base == NULL) {
	    base = (struct head *) malloc(sizeof(struct head));
	    strcpy(base->header, currhead->header);
	}
	
	currdom = (struct domain *) malloc(sizeof(struct domain));
	strcpy(currdom->header, leftm);
	currdom->headptr = currhead;		currdom->next=NULL;
	if (prevdom != NULL) prevdom->next=currdom;
	prevdom=currdom;
	if(basedom==NULL) basedom=currdom;
	
//	printf("\nHeader: %s\n\n", leftm);
	goto end_cicle;
    } 


    if ((linea[i] == '\n') || (linea[i-1] == '\n') || (linea[i] == '\0')) { 
//        printf ("vuota\n\n");
//	printf ("\n");
        goto end_cicle;
    } 
    
    while ( (linea[i] != ' ') && (linea[i]!='=') ) 
        leftm[k++] = linea[i++];
    leftm[k] = '\0';



    while (linea[i]!='=') i++;
    if (linea[i] == '=') i++;
    else goto end_cicle;
	
    currcell = (struct cell *) malloc(sizeof(struct cell));


    start_actions:

    memset(rightm, '\0', 128);		memset(parms, '\0', 128);

    while (linea[i] == ' ') i++;
    
    k=0;
    while ( ( (linea[i] >= 'a') && (linea[i] <= 'z')) || ( (linea[i] >= 'A') && (linea[i] <= 'Z')) || (linea[i] == '_') || (linea[i] == '-') )
        rightm[k++] = linea[i++];
    rightm[k] = '\0';

	
    k=0;
    while ((linea[i] == ' ') && (linea[i] != '\n')) i++;
	
    if (linea[i++] == '(') {
        while ( (linea[i] != ')') ) 
		parms[k++] = linea[i++];
	parms[k] = '\0';
	k=0;
    }
    
    curract = (struct action *) malloc(sizeof(struct action));    
    strcpy(currcell->event, leftm);
    strcpy(curract->action, rightm);
    strcpy(curract->parms, parms); 
    currcell->next_cell=NULL;
    if (prevact != NULL) { 
	prevact->next_action = curract;
	curract->prev_action = prevact;
    } else currcell->actions = curract;
    prevact = curract;    
//    printf("currcell->event: %s\n", currcell->event);
//    printf("curract->action: %s\n", curract->action);
//    printf("curract->parms: %s\n", curract->parms);    
//    printf("%s = %s(%s)\n", currcell->event, curract->action, curract->parms);    

	     // nel caso della go, per adesso copiamo solo il nome della tabella
	    // quando ci saranno in memoria tutte le tabelle, aggiorniamo i puntatori
    if (strcmp(curract->action, "go") == 0) {
	currgo = (struct go *) malloc(sizeof(struct go));
	currgo->actionptr = curract;
	if (prevgo != NULL) prevgo->next=currgo;
	prevgo=currgo;
	if (basego==NULL) basego=currgo;
    }

    i++;
    while ((linea[i] == ' ') && (linea[i] != '\n')) i++;
        
    if ( (linea[i-1] == ',') ||  (linea[i] == ',')) {
	i++;
	goto start_actions;
    }
    
    if (base->table == NULL) base->table = currcell;
    if (currhead->table == NULL) currhead->table = currcell;	// nuovo dominio
    else {
	if (prevcell != NULL) prevcell->next_cell=currcell; // vecchio dominio
	currcell->prev_cell = prevcell;
    }
    prevcell = currcell;
    
//    printf("\nleft_member: %s\n", leftm);
//    printf("right_member: %s\n", rightm);
//    printf("parms: %s\n\n", parms);
    

end_cicle:    

    i=0; k=0;
    memset(linea, '\0', 1024);     	memset(leftm, '\0', 128); 
    curract = NULL; prevact = NULL;



}	// end while(nread)
    
    
    // aggiusta i puntatori delle azioni "go", facendoli puntare alle tabelle
    currgo=basego;  currdom=basedom;  esci=0;
    while(currgo != NULL) {
	while ( (currdom != NULL) && (!esci)) {
//	    printf("parms: %s, header: %s\n", currgo->cellptr->parms, currdom->header );
	    if (strcmp(currgo->actionptr->parms, currdom->header) != 0) 
		currdom=currdom->next;
	    else esci = 1;
    	}
	if (currdom!=NULL)
	    currgo->actionptr->next_table=currdom->headptr;
	else { printf("Manca il dominio di:  %s = %s(%s)\n\n", " ", currgo->actionptr->action, currgo->actionptr->parms);  exit(-1);}
	currgo = currgo->next;
	currdom=basedom;
	esci=0;
    }
    
    strcpy(basedom->con_name, con_name);

close(fileptr);

return basedom;

}



int print_rules(struct domain *basedom) {

struct domain *currdom=NULL;
struct cell *currcell=NULL;
struct action *curract=NULL;


    currdom = basedom; 
    while (currdom != NULL) {
	printf("\n[%s]\n\n", currdom->header);
	currcell = currdom->headptr->table;
	while (currcell != NULL) {
	    curract = currcell->actions;
    	    printf("%s = %s(%s)", currcell->event, curract->action, curract->parms);
	    curract = curract->next_action;
//	    if (curract == NULL) printf("NULL\n");
//    	    else printf("%s = %s(%s)", currcell->event, curract->action, curract->parms);
	    while (curract != NULL) {
    		printf(", %s(%s)", curract->action, curract->parms);
		curract = curract->next_action;
	    }
	    printf("\n");
	    currcell=currcell->next_cell;
	}
	currdom = currdom->next;
	printf("\n");
    }


return 0;
}



